#include<iostream>
using namespace std;

long long n,li,di,i,d;

int main(){
	cin>>n;
	long long a[n];
	
	for(i=0;i<n;i++)cin>>a[i];
	
	
	d=n-1;
	li=-1;
	
	
	for(i=n-1;i>=0;i--)if(a[d]<a[i]){
		
		d=i;
	}
	else if(a[i]<a[d]){
		li=i;
		di=d;
	}
	if(li==-1){
		for(i=1;i<n;i++)if(a[i]==a[i-1])break;
		li=n-2;
		di=n-1;
	}
	if(li!=-1)swap(a[li],a[di]);
	for(i=0;i<n;i++)cout<<a[i]<<" ";
	return 0;
}